%Skriptet er skrevet av Andreas Gjaerum og baserer seg p
%tilnrmingen presentert i artikkelen "Static equivalent method for 
%kinematic interaction analysis of single piles" av Francesca Dezi, Sandro
%Carbonari og Graziano Leoni.
%Jorden egenskaper plottes fra overflaten og neodover.
%OBS vikitg  legge inn et lagskille p enden til en flytende pel.



S=input('Antall jordlag='); 
%henter informasjon om totalt antall jordlag. For analyser med mange lag
%vil skripetet muligens bruke litt tid p beregningene da Matlab's Symbolic
%Toolbox er brukt i store deler av skriptet.

I=Infojord(S);                                      
%henter inn informasjon om jorda

P=Infopel(I,S);                                     
%henter inn info om pelen og identifiserer randlaget til pelen

ag=input('agR (=0,8*ag40Hz) =');                         
%henter inn grunnakselerasjon

gamma=input('seismisk faktor fra EC8=');                    
%henter inn seismisk faktor 

n=input('n(dempnings modifikasjonsfaktor fra EC8)=') ;                                              
%dempningen angis ved modifikajsonfaktoren fra 3.2.2 (3) NS-EN 1998

M=H_Matrise(S,I);                      
%lager matrisen med randbetingelsene for egenverdi problemet.
                    %F=egenmode(M);
w=functionsolver(M);              
%beregner 6 sirkulre egenfrekvensene fra H(w)-matrisenen 

C=integrasjonskonstant1 (w,S,M);        
%beregner integralfunksjonene A1,A2,B2,A3,B3 etc..

D=Formfunksjon(S,I,w,C);         
%gir formfunksjonen til de ulike svingemnstrene

M=Modal_masse(D,I,S);
% beregner modalmasse

G=Gamma(M,D,I,S);                                     
%beregner transformasjonsfaktoren

R=Designspektrum(ag,n,gamma);
%lager responsspektrumet etter grunntype A EC8 

Sdw=Spektral_forskyvning(w,R);
%beregner pseudo-deformasjon for jordprofilets egenfrekvenser

AB=AlfaogBeta (I,P,w);                                
%gir alfa og beta verdiene til pelens deformasjon

C1=integrasjonskonstant2(AB,C,P,G,Sdw,I);
%identifisererpelens integralkonstanter C1,C2,C3 og C4

[M,V]=Omhylling(P,C,C1,AB,G,Sdw);
%finner omhyllingskurvene til de ulike svingemnstrene

[Mtot,Vtot]=Totalt(M,V,P,w,n);                           
% Superponerer pelens respons for ulike svingemnstre ved CQC

[Mmax,Vmax,Tot]=Plot2(Mtot,Vtot,P,I)
%Plotter pelen totale omhyllingskurve, og gir maksimal respons



