function C1=integrasjonskonstant2(AB,C,P,G,Sdw,I)
%beregner integrasjonskonstantene til pelens deformasjon

%4 integrasjonskonstanter pr lag for 6 ulike svingemnstre
C1=zeros(4*P(3),6)   

% bruker matrise regning for  finne integrasjonskonstantene
% Hvor B*X=A, slik at X=A*B^(-1) hvor X er integrasjonskonstantene.
B=zeros(4*P(3),1)
A=zeros(4*P(3),4*P(3))

    %randbetingelser for for toppen av pelen;
        
        %u'm1(0)=0 betingelse
        A(1,1)=-AB(1,1);                             
        A(1,2)=AB(1,1);
        A(1,3)=AB(1,1);
        A(1,4)=AB(1,1);
        B(1,1)=0;
        
        %u'''m1(0)=0 betingelse
        A(2,1)=2*AB(1,1)^3;                                      
        A(2,2)=2*AB(1,1)^3;
        A(2,3)=-2*AB(1,1)^3;
        A(2,4)=2*AB(1,1)^3;
        B(2,1)=0;
 
     %kjrer for de ulike svingemnstrene    
for j=1:1:6;                                
    %randbetingelser for midtre delen av pelen   
    if P(3)>=2;                         
        for i=1:1:(P(3)-1);
        
            a1=AB(i,1);
            a2=AB(i+1,1);
            b=AB(i,1)*I(3,i);                            
            c=sin(b)+cos(b);
            d=-sin(b)+cos(b);         
            e1=exp(-b);
            e2=exp(b);
            k=(i-1)*4 ;        %gir et hopp p fire for kningen av i
            
            %beta verdiene for lag i og i+1
            Beta1=AB(i,2+(j-1)*2);
            Beta2=AB(i+1,2+(j-1)*2);
            %konstant leddet med Gammma og Sd for lag i og i+1
            CM1=(4*G(1,j)*Sdw(1,j)*a1^4)/(Beta1^4+4*a1^4);           
            CM2=(4*G(1,j)*Sdw(1,j)*a2^4)/(Beta2^4+4*a2^4);
            
            %integrasjonskonstanter for jordens formsfunksjon
            A1=C(1+(i-1)*2,j);       
            B1=C(2+(i-1)*2,j);      
            A2=C(3+(i-1)*2,j);      
            B2=C(4+(i-1)*2,j);      
            
            %umi(hi)=umi+1(0) kontinuitet betingelse
            A(3+k,1+k)=e1*cos(b);       
            A(3+k,2+k)=e1*sin(b);
            A(3+k,3+k)=e2*cos(b);
            A(3+k,4+k)=e2*sin(b);
            A(3+k,5+k)=-1;
            A(3+k,7+k)=-1;
            B(3+k,1)=CM2*A2-CM1*(A1*cos(Beta1*I(3,i))+B1*sin(Beta1*I(3,i)));
            
            %u'mi(hi)=u'mi+1(0) kontinuitet vinkel
            A(4+k,1+k)=a1*e1*(-c);                
            A(4+k,2+k)=a1*e1*(d);
            A(4+k,3+k)=a1*e2*(d);
            A(4+k,4+k)=a1*e2*(c);
            A(4+k,5+k)=a2;
            A(4+k,6+k)=-a2;
            A(4+k,7+k)=-a2;
            A(4+k,8+k)=-a2;
            B(4+k,1)=CM2*B2*Beta2-CM1*(-A1*Beta1*sin(Beta1*I(3,i))+B1*Beta1*cos(Beta1*I(3,i)));
            
            %u''mi(hi)=u''mi+1(0) kontinuitet moment
            A(5+k,1+k)=2*a1^2*e1*sin(b);                    
            A(5+k,2+k)=-2*a1^2*e1*cos(b);
            A(5+k,3+k)=-2*a1^2*e2*sin(b);
            A(5+k,4+k)=2*a1^2*e2*cos(b);
            A(5+k,6+k)=2*a2^2;
            A(5+k,8+k)=-2*a2^2;
            B(5+k,1)=-CM2*A2*Beta2^2-CM1*(-A1*Beta1^2*cos(Beta1*I(3,i))-B1*Beta1^2*sin(Beta1*I(3,i)));
            
            %u'''mi(hi)=umi+1(0) kontinitet skjr 
            A(6+k,1+k)=2*a1^3*e1*(d);                         
            A(6+k,2+k)=2*a1^3*e1*(c);
            A(6+k,3+k)=2*a1^3*e2*(-c);
            A(6+k,4+k)=2*a1^3*e2*(d);
            A(6+k,5+k)=-2*a2^3;
            A(6+k,6+k)=-2*a2^3;
            A(6+k,7+k)=2*a2^3;
            A(6+k,8+k)=-2*a2^3;
            B(6+k,1)=-CM2*B2*Beta2^3-CM1*(A1*Beta1^3*sin(Beta1*I(3,i))-B1*Beta1^3*cos(Beta1*I(3,i)));
        end    
    end
    %randbetingelse for nedre del av pelen;
    
         i=P(3);
         a1=AB(i,1);                                 
         b=AB(i,1)*I(3,i);                            
         c=sin(b)+cos(b);
         d=-sin(b)+cos(b);                     
         e1=exp(-b);
         e2=exp(b);
         
        Beta1=AB(i,2+(j-1)*2);
        CM1=(4*G(1,j)*Sdw(1,j)*a1^4)/(Beta1^4+4*a1^4);           
        A1=C(1+(i-1)*2,j);                                   
        B1=C(2+(i-1)*2,j);                                   
                                            
        %fri-rotasjon-i-toppen-av-pelen-randbetingelsen 
        %u1''(0)=0 ingen moment i toppen kan aktiveres hvis man skal se p
        %A(1,1)=0;            
        %A(1,2)=-2*AB(1,1)^2;
        %A(1,3)=0;
        %A(1,4)=2*AB(1,1)^2;
        %B(1,1)=(4*G(1,j)*Sdw(1,j)*AB(1,1)^4)/(AB(1,2+(j-1)*2)^4+4*AB(1,1)^4)*C(1,j)*AB(1,2+(j-1)*2)^2;
        
        %u''mp(hp)=0 ingen skjr i bunnen av plelen
        A(4*P(3)-1,4*P(3)-3)=2*a1^2*e1*sin(b);       
        A(4*P(3)-1,4*P(3)-2)=-2*a1^2*e1*cos(b);
        A(4*P(3)-1,4*P(3)-1)=-2*a1^2*e2*sin(b);
        A(4*P(3)-1,4*P(3))=2*a1^2*e2*cos(b);
        B(4*P(3)-1,1)=-CM1*(-A1*Beta1^2*cos(Beta1*I(3,i))-B1*Beta1^2*sin(Beta1*I(3,i)));
        
        %u'''mp(hp)=0 ingen moment i bunnen av pelen
        A(4*P(3),4*P(3)-3)=2*a1^3*e1*(d);            
        A(4*P(3),4*P(3)-2)=2*a1^3*e1*(c);
        A(4*P(3),4*P(3)-1)=2*a1^3*e2*(-c);
        A(4*P(3),4*P(3))=2*a1^3*e2*(d); 
        B(4*P(3),1)=-CM1*(A1*Beta1^3*sin(Beta1*I(3,i))-B1*Beta1^3*cos(Beta1*I(3,i)));
        
        %beregner det linere ligningssystemet B*X=A  for det j'te 
        %svingemnsteret
       
        D=linsolve(A,B);
        
        for i=1:1:4*P(3);
            C1(i,j)=D(i);
        end
end
            
            
            
            
       
        
    
